function z=getboundaries(snodes,x)
s=gridmake(snodes);
[n,d]=size(s);
m=size(x,2);
z=cell(m,m);
xx=zeros(5,m,d);
addfactor=ones(1,d); 
for i=1:d-1, addfactor(i+1)=addfactor(i)*size(snodes{i}+1,1); end
for p=1:m                                        % loop over regimes 
  k=zeros(1,m);
  for i=1:n-1                                    % check all points
    xi=x(i,p);                                   % the optimal regime at point i
    for j=1:d                                    % loop over upper neighbors
      ij=i+addfactor(j);                         % index of neighbor
      if ij<=n  & all(s(i,:)<=s(ij,:))           % check if below upper boundary
        xij=x(ij,p);                             % the optimal regime at point ij 
        if xij~=xi                               % if regime changes between neighbors
          if xij==p, xij=xi; end
          k(xij)=k(xij)+1;
          xx(k(xij),xij,:)=(s(i,:)+s(ij,:))/2;
        end
      end
    end
  end
  for j=1:m, z{p,j}=sortrows(squeeze(xx(1:k(j),j,:)),1:d); end
end
