#include "mex.h"
#include <math.h>

/*
MINCOL Returns the minimal value in each column of a matrix
z=mincol(x);
*/

double *mincol(double *A, double *B, int m, int n)
{
  double temp;
  int  i,j;
  for (i=0; i<m; i++) B[i]=*A++;
  for (j=1; j<n; j++) for (i=0; i<m; i++) {temp=*A++; if (B[i]>temp) B[i]=temp;}
  return(B);
}


void mexFunction(
   int nlhs, mxArray *plhs[],
   int nrhs, const mxArray *prhs[])
{
  int m, n;
   
  if (nrhs<1) mexErrMsgTxt("No input argument passed.");
  m=mxGetM(prhs[0]);
  n=mxGetN(prhs[0]);
  if (mxIsComplex(prhs[0])) mexErrMsgTxt("Matrix must be real");
  plhs[0]=mxCreateDoubleMatrix(m,1,mxREAL);
  mincol(mxGetPr(prhs[0]),mxGetPr(plhs[0]),m,n);
}