% MINERES Residual function for finding switchpoint of mine example
% Called with
% sstar=broyden('mineres',sstar0,beta1,beta2,mu,sigma,rho,h,k,C12,C21);
function [res,A]=mineres(sstar,beta1,beta2,mu,sigma,rho,h,k,C12,C21)
S1=sstar(1);
S2=sstar(2);
A=[-S1.^beta1  S1.^beta2; ...
    S2.^beta1 -S2.^beta2]\...
  [C12-h*S1/(rho-mu+h)+k/rho;
   C21+h*S2/(rho-mu+h)-k/rho];
res=[beta1*A(1)*S1.^(beta1-1)-h/(rho-mu+h)-beta2*A(2)*S1.^(beta2-1);...
     beta1*A(1)*S2.^(beta1-1)-h/(rho-mu+h)-beta2*A(2)*S2.^(beta2-1)];